unit glavno;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, poteze, ComCtrls, Spin;

type
  TfrmGlavno = class(TForm)
    pbGlavno: TPaintBox;
    lbPoteze: TListBox;
    btBrisiI: TButton;
    tbCrte: TTrackBar;
    lblCrte: TLabel;
    tbKrogi: TTrackBar;
    lblKrogi: TLabel;
    btBrisiVse: TButton;
    cbBezier: TCheckBox;
    cbElipse: TCheckBox;
    seMreza: TSpinEdit;
    cbMreza: TCheckBox;
    cbIzris: TCheckBox;
    cbKoti: TCheckBox;
    seKoti: TSpinEdit;
    rbZacetek: TRadioButton;
    rbKonec: TRadioButton;
    procedure osvezi (sender: TObject);
    procedure pbGlavnoMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure pbGlavnoMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure btBrisiIClick(Sender: TObject);
    procedure tbCrteChange(Sender: TObject);
    procedure pbGlavnoMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure btBrisiVseClick(Sender: TObject);
    procedure seMrezaChange(Sender: TObject);
    procedure seKotiChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmGlavno: TfrmGlavno;

implementation

{$R *.DFM}

procedure TfrmGlavno.osvezi (sender: TObject);
  var
    i, j, mreza, koti: integer;
    zacPot: Poteza;
    barva: TColor;
begin
  pbGlavno.canvas.brush.color:=clWhite;
  pbGlavno.canvas.fillRect (rect (0, 0, pbGlavno.width, pbGlavno.height));
  if (cbMreza.checked) and (cbIzris.checked) then
    for i:=0 to pbGlavno.width div seMreza.value do
      for j:=0 to pbGlavno.height div seMreza.value do
        pbGlavno.canvas.pixels [i*seMreza.value, j*seMreza.value]:=clBlue;
  for i:=0 to lbPoteze.items.count-1 do begin
    zacPot:=Poteza (lbPoteze.items.objects [i]);
    if i=lbPoteze.itemIndex then
      barva:=clRed
    else
      barva:=clBlack;
    if cbMreza.checked then
      mreza:=seMreza.value
    else
      mreza:=0;
    if cbKoti.checked then
      koti:=seKoti.value
    else
      koti:=0;
    zacPot.narisi (pbGlavno.canvas, barva, tbCrte.position, tbKrogi.position, cbBezier.checked, cbElipse.checked, mreza, koti, rbZacetek.checked);
    lbPoteze.items [i]:=zacPot.ime;
  end;
end;

procedure TfrmGlavno.pbGlavnoMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
  var
    novaPoteza: Poteza;
begin
  pbGlavno.canvas.moveTo (x, y);
  novaPoteza:=Poteza.create;
  novaPoteza.dodajTocko (x, y);
  lbPoteze.items.addObject (novaPoteza.ime, novaPoteza);
end;

procedure TfrmGlavno.pbGlavnoMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if shift=[ssLeft] then begin
    pbGlavno.canvas.pen.color:=clBlack;
    pbGlavno.canvas.lineTo (x, y);
    Poteza (lbPoteze.items.objects [lbPoteze.items.count-1]).dodajTocko (x, y);
  end;
end;

procedure TfrmGlavno.pbGlavnoMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if (tbCrte.position>0) or (tbKrogi.position>0) then
    osvezi (sender);
end;

procedure TfrmGlavno.tbCrteChange(Sender: TObject);
  var
    i: integer;
begin
  for i:=0 to lbPoteze.items.count-1 do
    Poteza (lbPoteze.items.objects [i]).tip:=TPnic;
  osvezi (sender);
end;

procedure TfrmGlavno.seMrezaChange(Sender: TObject);
begin
  if cbMreza.checked then
    osvezi (sender);
end;

procedure TfrmGlavno.seKotiChange(Sender: TObject);
begin
  if cbKoti.checked then
    osvezi (sender);
end;

procedure TfrmGlavno.btBrisiIClick(Sender: TObject);
begin
  if lbPoteze.itemIndex>-1 then begin
    lbPoteze.items.objects [lbPoteze.itemIndex].free;
    lbPoteze.items.delete (lbPoteze.itemIndex);
    osvezi (sender);
  end;
end;

procedure TfrmGlavno.btBrisiVseClick(Sender: TObject);
  var
    i: integer;
begin
  for i:=0 to lbPoteze.items.count-1 do
    lbPoteze.items.objects [i].free;
  lbPoteze.items.clear;
  osvezi (sender);
end;

end.
